import 'package:flutter/material.dart';
import 'package:flutter_yfree/YFree.dart';

const zh = Locale("zh"), en = Locale("en");

String getLanguage(Locale? locale) {
  if (locale == null) return "自动".yLocale();
  if (locale.languageCode == zh.languageCode) {
    return "中文(简体)";
  } else if (locale.languageCode == en.languageCode) {
    return "English";
  }
  return "";
}

final localizations = {
  "": {zh: "", en: ""},
  "自动": {zh: "自动", en: "Auto"},
  "模拟广播": {zh: "模拟广播", en: "Imitate Broadcast"},
  "切换语言": {zh: "切换语言", en: "Change Language"},
};
